VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "radioButtons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'' Usage: Initialization (module code or worksheet code)
'' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'Dim radioButtonGroup As New radioButtons

'Public Sub init()
'
'    With radioButtonGroup
'
'       ' attach chart object. class can handle its events now
'       Set .Container = ActiveSheet.ChartObjects("buttonGroups2").Chart
'
'       ' add buttons
'       .addButton "radioButton_aufst", "aufst.", "radioButton_OnClick"
'       .addButton "radioButton_abst", "abst.", "radioButton_OnClick"
'
'
'       ' initialize buttonGroup
'       .init
'
'    End With
'
'End Sub
'
'' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'' Usage: Reacting to click event (module code)
'' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'Public Sub radioButton_OnClick(buttonName As String)
'
'    Debug.Print buttonName & " clicked"
'
'End Sub


'
'
' Private variables
'
'

' template shape for deactivated radio button
Private deaTpl As shape

' template shape for activated radio button
Private actTpl As shape

' template shape for button caption
Private capTpl As shape

' Button Container (ChartObject.Chart)
Private WithEvents pContainer As Chart
Attribute pContainer.VB_VarHelpID = -1

' pRadiobuttons: radioButtons as initialized by user-code
' contains collections with the following elements
'   "name": Name of Button
'   "text": Caption Text
'   "onAction": Name of Callback Procedure
'   "activated": Shape
'   "deactivated": Shape
'   "caption": Shape
Private pRadioButtons As Collection

Private pShapes As Shapes

' Selecting triggers Event handler repeatedly - must be suppressed during when handling
Private suppressCapturedEvent As Boolean

Private pIsAttached As Boolean

'
'
' System Functions
'
'

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Declare Sub GetSystemTime Lib "kernel32" _
(lpSystemTime As SYSTEMTIME)

Public Function TimeStamp() As String
    Dim tSystem As SYSTEMTIME
    Dim sRet
    On Error Resume Next
    GetSystemTime tSystem
    sRet = Hour(Now) & ":" & Minute(Now) & ":" & Second(Now) & _
    ":" & tSystem.wMilliseconds
    TimeStamp = Replace(sRet, ":", "")
End Function

'Read more at http://vbadud.blogspot.com/2008/10/excel-vba-timestamp-milliseconds-using.html#ugwKRPYFHMJy2Hat.99



'
'
' Properties
'
'

Public Property Get Container() As Chart
    Set Container = pContainer
End Property

Public Property Set Container(v As Chart)
    Set pContainer = v
    Set pShapes = pContainer.Shapes
End Property


Public Property Get isAttached() As Boolean
    isAttached = pIsAttached
End Property





'
'
' Class Initialization
'
'

Private Sub Class_Initialize()
    Set pRadioButtons = New Collection
    suppressCapturedEvent = False
    pIsAttached = False
End Sub




'
'
' Public Functions
'
'

Public Function addButton(name As String, text As String, macro As String, _
                Optional state As String, Optional jumpTarget As String) As radioButtons
    
    Dim rb As New Collection
    
    rb.Add name, "name"
    rb.Add text, "text"
    rb.Add macro, "macro"
    
    If state = "" Then rb.Add "deactivated", "state"
    If state = "activated" Or state = "deactivated" Then rb.Add state, "state"
    
    If jumpTarget = "" Then
        rb.Add "A1", "jumpTarget"
    Else
        rb.Add jumpTarget, "jumpTarget"
    End If
    
    pRadioButtons.Add rb, name
    
    Set addButton = Me
    
End Function



Public Sub init()
' either prepares the container (draws buttons based on templates)
' or attaches to an already prepared container

    ' prepare container and shapes
    If getTemplateShapes = True Then
        
        prepareContainer
    
    Else
        If shapesCorrespondToRadioButtons = False Then
            
            MsgBox "For each radioButton in Initialization an activated," & vbCrLf & _
                   " deactivated and caption shape must be present.", _
                   vbCritical, "Error initializing button group container!"
    
        Else
        
            attachToContainer

        End If
    End If
    
    pIsAttached = True
    
End Sub




'
'
' Event Handler
'
'

Private Sub pContainer_Select(ByVal typeOfElement As Long, _
        ByVal shapeIndex As Long, ByVal Arg2 As Long)
 
    If suppressCapturedEvent = True Then Exit Sub
    
    ' Deselect triggers this event again, so suppress it
    suppressCapturedEvent = True
    
    Dim pRb As Collection, shpGroup As shape, i As Integer
    Dim shpName As String, rbName As String
    
    shpName = pContainer.Shapes(shapeIndex).name
    rbName = deriveButtonName(shpName)
    Set pRb = pRadioButtons(rbName)
    
    Range(pRb("jumpTarget")).Select
    
    If Not pRb("activated").visible Then
    
        ' deactivate all buttons (hide "activated"-button)
        For i = 1 To pRadioButtons.Count
            pRadioButtons(i)("activated").visible = msoFalse
        Next i
    
        ' toggle
        pRb("activated").visible = msoTrue
    
        Application.Run pRb("macro"), pRb("name")
    
    End If
    
    suppressCapturedEvent = False
    
    
        
    
End Sub



'
'
' Private Helper Procedures
'
'


Private Sub prepareContainer()
' prepares the container: draws buttons based on templates
' pre-conditions: only template shapes exist in container and template
' shapes must have the titles "activated", "deactivated" and "caption"

    Dim radio As Collection, atPosition As Integer, i As Integer
    Dim rbDea As shape, rbAct As shape, rbCap As shape, newShpGroup As shape
    
    For i = 1 To pRadioButtons.Count
    
        Set rbDea = copyPasteShape(deaTpl)
        Set rbAct = copyPasteShape(actTpl)
        Set rbCap = copyPasteShape(capTpl)
        
        prepareButton i, rbDea, rbAct, rbCap
    
    Next i
    
    deaTpl.Delete
    actTpl.Delete
    capTpl.Delete

End Sub




Private Sub attachToContainer()
' attaches the class to an already prepared container
    
    Dim i As Integer, rbAct As shape, pRb As Collection
    
    For i = 1 To pRadioButtons.Count
        Set pRb = pRadioButtons(i)
        pRb.Add pContainer.Shapes(pRb("name") & "_activated"), "activated"
        pRb.Add pContainer.Shapes(pRb("name") & "_deactivated"), "deactivated"
        pRb.Add pContainer.Shapes(pRb("name") & "_caption"), "caption"
    
        ' set initial state
        Set rbAct = pRb("activated")
        If pRb("state") = "deactivated" Then rbAct.visible = msoFalse
        If pRb("state") = "activated" Then rbAct.visible = msoTrue
    
    Next i

End Sub



Private Function getTemplateShapes() As Boolean
' tries to assign existing shapes in container to template shapes
' and returns false if no templates are present
    
    Dim sNames As Collection
    
    getTemplateShapes = True
    
    If pShapes.Count = 3 Then
        
        Set sNames = New Collection
        
        sNames.Add pShapes(1), pShapes(1).title
        sNames.Add pShapes(2), pShapes(2).title
        sNames.Add pShapes(3), pShapes(3).title
        
        On Error GoTo errhandler
        Set actTpl = sNames("activated")
        Set deaTpl = sNames("deactivated")
        Set capTpl = sNames("caption")
        On Error GoTo 0
    
    Else
        getTemplateShapes = False
        Exit Function
    End If
    Exit Function
    
errhandler:
    Err.Clear
    getTemplateShapes = False
    
End Function



Private Function shapesCorrespondToRadioButtons() As Boolean
    
    Dim pRb As Collection, testShape As shape
    
    shapesCorrespondToRadioButtons = True
    
    On Error GoTo errhandler
    
    For Each pRb In pRadioButtons
        Set testShape = pContainer.Shapes(pRb("name") + "_activated")
        Set testShape = pContainer.Shapes(pRb("name") + "_deactivated")
        Set testShape = pContainer.Shapes(pRb("name") + "_caption")
    Next
    
    Exit Function
    
errhandler:
    Err.Clear
    shapesCorrespondToRadioButtons = False
    On Error GoTo 0
    
End Function



Private Function copyPasteShape(shp As shape) As shape
    
    Dim originalName As String, newName As String
    
    originalName = shp.name
    newName = originalName & TimeStamp()
    
    shp.name = newName
    
    suppressCapturedEvent = True
    
    shp.Copy
    pContainer.Paste
    
    suppressCapturedEvent = False

    shp.name = originalName
    Set copyPasteShape = pContainer.Shapes(newName)

End Function



Private Sub prepareButton(buttonIndex As Integer, rbDea As shape, rbAct As shape, rbCap As shape)
' prepares a single button in the group from given template elements

    On Error GoTo errhandler
    
    Dim grpShape As shape, grpWidth As Integer, grpHeight As Integer
    Dim contHeight As Integer, pRb As Collection
    
    suppressCapturedEvent = True
    
    Set pRb = pRadioButtons(buttonIndex)
    
    pRb.Add rbAct, "activated"
    pRb.Add rbDea, "deactivated"
    pRb.Add rbCap, "caption"
    
    ' positioning of single shapes
    contHeight = pContainer.Parent.Height
    rbAct.left = (rbAct.Width + rbCap.Width) * (buttonIndex - 1) + 2
    rbDea.top = rbAct.top
    rbDea.left = rbAct.left
    rbCap.top = (contHeight - rbCap.Height) / 2
    rbCap.left = rbAct.left + rbAct.Width + 1
       
    
    ' naming + caption
    rbDea.name = pRb("name") & "_deactivated"
    rbAct.name = pRb("name") & "_activated"
    rbCap.name = pRb("name") & "_caption"
    rbCap.TextFrame2.TextRange.text = pRb("text")
    
    ' set initial state
    If pRb("state") = "deactivated" Then rbAct.visible = msoFalse
    If pRb("state") = "activated" Then rbAct.visible = msoTrue
    
    suppressCapturedEvent = False
    
    Exit Sub

errhandler:
    Debug.Assert False
    Resume
    Err.Clear
    
End Sub



Private Function deriveButtonName(shapeName As String) As String
    deriveButtonName = Replace(Replace(Replace(shapeName, "_caption", ""), "_deactivated", ""), "_activated", "")
End Function
